# Copyright 1999-2023 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2

EAPI=8

# ebuild generated by hackport 0.8.4.0.9999

CABAL_FEATURES="lib profile haddock hoogle hscolour test-suite"
inherit haskell-cabal

DESCRIPTION="Generate driver file for doctest's cabal integration"
HOMEPAGE="https://github.com/Hexirp/doctest-driver-gen#readme"

LICENSE="BSD"
SLOT="0/${PV}"
KEYWORDS="~amd64 ~arm64 ~ppc64 ~riscv ~x86"
IUSE="+executable"

PATCHES=(
	"${FILESDIR}/${PN}-0.3.0.7-add-executable-flag.patch"
)

RDEPEND="
	>=dev-lang/ghc-8.10.6:=
"
DEPEND="
	${RDEPEND}
	>=dev-haskell/cabal-3.2.1.0
	test? (
		dev-haskell/doctest
	)
"

src_configure() {
	local config_flags=(
		$(cabal_flag executable executable)
	)

	haskell-cabal_src_configure "${config_flags[@]}"
}
